VatHistory: Add ability to trace file executions
[csit.git] / bootstrap-verify-perf-ligato.sh
1 #!/bin/bash
2 # Copyright (c) 2017 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -xo pipefail
16
17 # Space separated list of available testbeds, described by topology files
18 TOPOLOGIES="topologies/available/lf_testbed1.yaml \
19             topologies/available/lf_testbed2.yaml \
20             topologies/available/lf_testbed3.yaml"
21
22 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
23
24 # Reservation dir
25 RESERVATION_DIR="/tmp/reservation_dir"
26 INSTALLATION_DIR="/tmp/install_dir"
27
28 PYBOT_ARGS="-W 150 -L TRACE"
29
30 ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
31
32 # If we run this script from CSIT jobs we want to use stable vpp version
33 if [[ ${JOB_NAME} == csit-* ]] ;
34 then
35     mkdir -p vpp/build-root
36     cd vpp/build-root
37
38     if [[ ${TEST_TAG} == *NIGHTLY ]] || \
39        [[ ${TEST_TAG} == *DAILY ]] || \
40        [[ ${TEST_TAG} == *WEEKLY ]];
41     then
42         # Download the latest VPP build .deb install packages
43         echo Downloading VPP packages...
44         bash ${SCRIPT_DIR}/resources/tools/scripts/download_install_vpp_pkgs.sh --skip-install
45
46         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
47         # Take vpp package and get the vpp version
48         VPP_STABLE_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
49     else
50         DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
51         VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
52         VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
53         VPP_CLASSIFIER="-deb"
54         # Download vpp build from nexus and set VPP_DEBS variable
55         wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
56         wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
57         wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
58         # Temporary disable using dpdk
59         # wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
60         wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
61         wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
62         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
63     fi
64
65     # Temporary workaround as ligato docker file requires specific file name
66     rename -v 's/^(.*)-(\d.*)-deb.deb/$1_$2.deb/' *.deb
67     cd ${SCRIPT_DIR}
68
69 # If we run this script from vpp project we want to use local build
70 elif [[ ${JOB_NAME} == vpp-* ]] ;
71 then
72     mkdir -p vpp/build-root
73     # Use local packages provided as argument list
74     # Jenkins VPP deb paths (convert to full path)
75     VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
76     # Take vpp package and get the vpp version
77     VPP_STABLE_VER="$( expr match $1 'vpp-\(.*\)-deb.deb' )"
78     # Move files to build-root for packing
79     for deb in ${VPP_DEBS}; do mv ${deb} vpp/build-root/; done
80 else
81     echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
82     exit 1
83 fi
84
85 # Compress all VPP debs and remove temporary directory
86 tar -zcvf ${SCRIPT_DIR}/vpp.tar.gz vpp/*  && rm -R vpp
87
88 LIGATO_REPO_URL=$(cat ${SCRIPT_DIR}/LIGATO_REPO_URL)
89 VPP_AGENT_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_AGENT_STABLE_VER)
90 VPP_AGENT_STABLE_COMMIT="$( expr match `cat VPP_AGENT_STABLE_VER` '.*g\(.*\)' )"
91 DOCKER_DEB="docker-ce_17.09.0~ce-0~ubuntu_amd64.deb"
92
93 # Clone & checkout stable vnf-agent
94 cd .. && git clone ${LIGATO_REPO_URL}/vpp-agent
95 # If the git clone fails, complain clearly and exit
96 if [ $? != 0 ]; then
97     echo "Failed to run: git clone --depth 1 ${LIGATO_REPO_URL}/vpp-agent"
98     exit 1
99 fi
100 cd vpp-agent && git checkout ${VPP_AGENT_STABLE_COMMIT}
101 # If the git checkout fails, complain clearly and exit
102 if [ $? != 0 ]; then
103     echo "Failed to run: git checkout ${VPP_AGENT_STABLE_VER}"
104     exit 1
105 fi
106
107 # Install Docker
108 wget -q https://download.docker.com/linux/ubuntu/dists/xenial/pool/stable/amd64/${DOCKER_DEB}
109 sudo dpkg -i ${DOCKER_DEB}
110 # If installation fails, complain clearly and exit
111 if [ $? != 0 ]; then
112     echo "Failed to install Docker"
113     exit 1
114 fi
115
116 # Pull ligato/dev_vpp_agent docker image and re-tag as local
117 sudo docker pull ligato/dev-vpp-agent:${VPP_AGENT_STABLE_VER}
118 sudo docker tag ligato/dev-vpp-agent:${VPP_AGENT_STABLE_VER}\
119     dev_vpp_agent:latest
120 sudo docker images
121
122 # Build prod_vpp_agent docker image
123 cd ${SCRIPT_DIR}/../vpp-agent/docker/prod_vpp_agent/ &&\
124     mv ${SCRIPT_DIR}/vpp.tar.gz . &&\
125     ./extract_agent_files.sh &&\
126     sudo docker build -t prod_vpp_agent --no-cache .
127 # Export Docker image
128 sudo docker save prod_vpp_agent | gzip > prod_vpp_agent.tar.gz
129 # If image build fails, complain clearly and exit
130 if [ $? != 0 ]; then
131     echo "Failed to build vpp-agent Docker image."
132     exit 1
133 fi
134 DOCKER_IMAGE="$( readlink -f prod_vpp_agent.tar.gz | tr '\n' ' ' )"
135
136 cd ${SCRIPT_DIR}
137
138 sudo apt-get -y update
139 sudo apt-get -y install libpython2.7-dev python-virtualenv
140
141 WORKING_TOPOLOGY=""
142 export PYTHONPATH=${SCRIPT_DIR}
143
144 virtualenv --system-site-packages env
145 . env/bin/activate
146
147 echo pip install
148 pip install -r requirements.txt
149
150 # We iterate over available topologies and wait until we reserve topology
151 while :; do
152     for TOPOLOGY in ${TOPOLOGIES};
153     do
154         python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -t ${TOPOLOGY}
155         if [ $? -eq 0 ]; then
156             WORKING_TOPOLOGY=${TOPOLOGY}
157             echo "Reserved: ${WORKING_TOPOLOGY}"
158             break
159         fi
160     done
161
162     if [ ! -z "${WORKING_TOPOLOGY}" ]; then
163         # Exit the infinite while loop if we made a reservation
164         break
165     fi
166
167     # Wait ~3minutes before next try
168     SLEEP_TIME=$[ ( $RANDOM % 20 ) + 180 ]s
169     echo "Sleeping ${SLEEP_TIME}"
170     sleep ${SLEEP_TIME}
171 done
172
173 function cancel_all {
174     python ${SCRIPT_DIR}/resources/tools/scripts/topo_container_copy.py -c -d ${INSTALLATION_DIR} -t $1
175     python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -c -t $1
176 }
177
178 # On script exit we cancel the reservation and installation and delete all vpp
179 # packages
180 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
181
182 python ${SCRIPT_DIR}/resources/tools/scripts/topo_container_copy.py\
183     -t ${WORKING_TOPOLOGY} -d ${INSTALLATION_DIR} -i ${DOCKER_IMAGE}
184 if [ $? -eq 0 ]; then
185     echo "Docker image copied and loaded on hosts from: ${WORKING_TOPOLOGY}"
186 else
187     echo "Failed to copy and load Docker image to DUTs"
188     exit 1
189 fi
190
191 case "$TEST_TAG" in
192     # run specific performance tests based on jenkins job type variable
193     PERFTEST_DAILY )
194         pybot ${PYBOT_ARGS} \
195               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
196               -v DPDK_TEST:True \
197               -s "tests.kubernetes.perf" \
198               --include ndrdiscANDnic_intel-x520-da2AND1t1cORndrdiscANDnic_intel-x520-da2AND2t2c \
199               tests/
200         RETURN_STATUS=$(echo $?)
201         ;;
202     PERFTEST_SEMI_WEEKLY )
203         pybot ${PYBOT_ARGS} \
204               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
205               -v DPDK_TEST:True \
206               -s "tests.kubernetes.perf" \
207               --include ndrdiscANDnic_intel-x710AND1t1cORndrdiscANDnic_intel-x710AND2t2cORndrdiscANDnic_intel-xl710AND1t1cORndrdiscANDnic_intel-xl710AND2t2c \
208               tests/
209         RETURN_STATUS=$(echo $?)
210         ;;
211     VERIFY-PERF-NDRDISC )
212         pybot ${PYBOT_ARGS} \
213               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
214               -v DPDK_TEST:True \
215               -s "tests.kubernetes.perf" \
216               --include ndrdiscAND1t1cORndrdiscAND2t2c \
217               tests/
218         RETURN_STATUS=$(echo $?)
219         ;;
220     VERIFY-PERF-PDRDISC )
221         pybot ${PYBOT_ARGS} \
222               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
223               -v DPDK_TEST:True \
224               -s "tests.kubernetes.perf" \
225               --include pdrdiscAND1t1cORpdrdiscAND2t2c \
226               tests/
227         RETURN_STATUS=$(echo $?)
228         ;;
229     VERIFY-PERF-NDRCHK )
230         pybot ${PYBOT_ARGS} \
231               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
232               -v DPDK_TEST:True \
233               -s "tests.kubernetes.perf" \
234               --include ndrchkAND1t1cORndrchkAND2t2c \
235               tests/
236         RETURN_STATUS=$(echo $?)
237         ;;
238     PERFTEST_NDRCHK_DAILY )
239         pybot ${PYBOT_ARGS} \
240               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
241               -v DPDK_TEST:True \
242               -s "tests.kubernetes.perf" \
243               --include ndrchkAND1t1cORndrchkAND2t2c \
244               tests/
245         RETURN_STATUS=$(echo $?)
246         ;;
247     VERIFY-PERF-IP4 )
248         pybot ${PYBOT_ARGS} \
249               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
250               -v DPDK_TEST:True \
251               -s "tests.kubernetes.perf" \
252               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip4baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
253               tests/
254         RETURN_STATUS=$(echo $?)
255         ;;
256     VERIFY-PERF-IP6 )
257         pybot ${PYBOT_ARGS} \
258               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
259               -v DPDK_TEST:True \
260               -s "tests.kubernetes.perf" \
261               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip6baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
262               tests/
263         RETURN_STATUS=$(echo $?)
264         ;;
265     VERIFY-PERF-L2 )
266         pybot ${PYBOT_ARGS} \
267               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
268               -v DPDK_TEST:True \
269               -s "tests.kubernetes.perf" \
270               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDl2xcbaseORndrdiscANDnic_intel-x520-da2AND1t1cANDl2bdbase \
271               tests/
272         RETURN_STATUS=$(echo $?)
273         ;;
274     VERIFY-PERF-LISP )
275         pybot ${PYBOT_ARGS} \
276               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
277               -v DPDK_TEST:True \
278               -s "tests.kubernetes.perf" \
279               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDlisp \
280               tests/
281         RETURN_STATUS=$(echo $?)
282         ;;
283     VERIFY-PERF-VXLAN )
284         pybot ${PYBOT_ARGS} \
285               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
286               -v DPDK_TEST:True \
287               -s "tests.kubernetes.perf" \
288               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvxlan \
289               tests/
290         RETURN_STATUS=$(echo $?)
291         ;;
292     VERIFY-PERF-VHOST )
293         pybot ${PYBOT_ARGS} \
294               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
295               -v DPDK_TEST:True \
296               -s "tests.kubernetes.perf" \
297               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
298               tests/
299         RETURN_STATUS=$(echo $?)
300         ;;
301     VPP-VERIFY-PERF-IP4 )
302         pybot ${PYBOT_ARGS} \
303               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
304               -v DPDK_TEST:True \
305               -s "tests.kubernetes.perf" \
306               --include pdrchkANDnic_intel-x520-da2AND1t1cANDip4baseORpdrchkANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
307               tests/
308         RETURN_STATUS=$(echo $?)
309         ;;
310     VPP-VERIFY-PERF-IP6 )
311         pybot ${PYBOT_ARGS} \
312               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
313               -v DPDK_TEST:True \
314               -s "tests.kubernetes.perf" \
315               --include pdrchkANDnic_intel-x520-da2AND1t1cANDip6baseORpdrchkANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
316               tests/
317         RETURN_STATUS=$(echo $?)
318         ;;
319     VPP-VERIFY-PERF-L2 )
320         pybot ${PYBOT_ARGS} \
321               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
322               -v DPDK_TEST:True \
323               -s "tests.kubernetes.perf" \
324               --include pdrchkANDnic_intel-x520-da2AND1t1cANDl2xcbaseORpdrchkANDnic_intel-x520-da2AND1t1cANDl2bdbase \
325               tests/
326         RETURN_STATUS=$(echo $?)
327         ;;
328     VPP-VERIFY-PERF-LISP )
329         pybot ${PYBOT_ARGS} \
330               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
331               -v DPDK_TEST:True \
332               -s "tests.kubernetes.perf" \
333               --include pdrchkANDnic_intel-x520-da2AND1t1cANDlisp \
334               tests/
335         RETURN_STATUS=$(echo $?)
336         ;;
337     VPP-VERIFY-PERF-VXLAN )
338         pybot ${PYBOT_ARGS} \
339               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
340               -v DPDK_TEST:True \
341               -s "tests.kubernetes.perf" \
342               --include pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan \
343               tests/
344         RETURN_STATUS=$(echo $?)
345         ;;
346     VPP-VERIFY-PERF-VHOST )
347         pybot ${PYBOT_ARGS} \
348               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
349               -v DPDK_TEST:True \
350               -s "tests.kubernetes.perf" \
351               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
352               tests/
353         RETURN_STATUS=$(echo $?)
354         ;;
355     VPP-VERIFY-PERF-ACL )
356         pybot ${PYBOT_ARGS} \
357               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
358               -v DPDK_TEST:True \
359               -s "tests.kubernetes.perf" \
360               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDacl \
361               --include pdrdiscANDnic_intel-x520-da2AND2t2cANDacl \
362               tests/
363         RETURN_STATUS=$(echo $?)
364         ;;
365     PERFTEST_LONG )
366         pybot ${PYBOT_ARGS} \
367               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
368               -v DPDK_TEST:True \
369               -s "tests.kubernetes.perf" \
370               --exclude SKIP_PATCH \
371               -i NDRPDRDISC \
372               tests/
373         RETURN_STATUS=$(echo $?)
374         ;;
375     PERFTEST_SHORT )
376         pybot ${PYBOT_ARGS} \
377               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
378               -v DPDK_TEST:True \
379               -s "tests.kubernetes.perf" \
380               -i NDRCHK \
381               tests/
382         RETURN_STATUS=$(echo $?)
383         ;;
384     PERFTEST_NIGHTLY )
385         #run all available tests
386         pybot ${PYBOT_ARGS} \
387               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
388               -v DPDK_TEST:True \
389               -s "tests.kubernetes.perf" \
390               tests/
391         RETURN_STATUS=$(echo $?)
392         ;;
393     * )
394         # run full performance test suite and exit on fail
395         pybot ${PYBOT_ARGS} \
396               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
397               -v DPDK_TEST:True \
398               -s "tests.kubernetes.perf" \
399               tests/
400         RETURN_STATUS=$(echo $?)
401 esac
402
403 # Pybot output post-processing
404 echo Post-processing test data...
405
406 python ${SCRIPT_DIR}/resources/tools/scripts/robot_output_parser.py \
407        -i ${SCRIPT_DIR}/output.xml \
408        -o ${SCRIPT_DIR}/output_perf_data.xml \
409        -v ${VPP_STABLE_VER}
410 if [ ! $? -eq 0 ]; then
411     echo "Parsing ${SCRIPT_DIR}/output.xml failed"
412 fi
413
414 # Archive artifacts
415 mkdir -p archive
416 for i in ${ARCHIVE_ARTIFACTS[@]}; do
417     cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
418 done
419
420 echo Post-processing finished.
421
422 exit ${RETURN_STATUS}